<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Department</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container">
            <div class="row mb-2">
                <div class="col-sm-12 text-center">
                    <h1>Quản trị Phòng Ban</h1>
                </div>

                <div class="mb-3 mt-3 ml-3">
                    <button class="btn btn-success" id="btn-create-department">Thêm Phòng Ban mới</button>
                </div>

            </div>
        </div>
        <!-- /.container-fluid -->
    </section>
    <!-- Main content -->
    <section class="content">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-body">

                            <table class="table table-bordered table-striped table-hover text-center bg-light" id="album-table">
                                <thead>
                                    <tr>
                                        <th>STT</th>
                                        <th>Mã Phòng Ban</th>
                                        <th>Tên Phòng Ban</th>
                                        <th>Nghiệp vụ</th>
                                        <th>Giới thiệu</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>

                                </tbody>
                            </table>
                        </div>
                    </div>


                    <!-- modal create department-->
                    <div class="modal" id="modal-create-department" tabindex="-1" role="dialog">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title">Tạo Phòng Ban mới</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                                </div>
                                <div class="modal-body">
                                    <div class="col-12">
                                        <div class="row form-group">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Mã Phòng Ban</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-create-ma-phong-ban" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row form-group">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Tên Phòng Ban</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-create-ten-phong-ban" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row form-group">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Nghiệp vụ</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-create-nghiep-vu" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row form-group">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Giới thiệu</label>
                                            </div>
                                            <div class="col-8">
                                                <input id="inp-create-gioi-thieu" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="modal-footer">
                                    <button type="button" class="btn btn-success confirm-create">Tạo mới</button>
                                    <button type="button" class="btn btn-danger cancel-create" data-dismiss="modal">Hủy</button>
                                </div>
                            </div>
                        </div>
                    </div>

                    <!-- modal update department -->
                    <div class="modal" id="modal-update-department" tabindex="-1" role="dialog">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title">Cập nhật Phòng Ban</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                                </div>
                                <div class="modal-body">
                                    <div class="col-12">
                                        <div class="row form-group">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Mã Phòng Ban</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-update-ma-phong-ban" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row form-group">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Tên Phòng Ban</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-update-ten-phong-ban" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row form-group">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Nghiệp vụ</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-update-nghiep-vu" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row form-group">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Giới thiệu</label>
                                            </div>
                                            <div class="col-8">
                                                <input id="inp-update-gioi-thieu" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="modal-footer">
                                    <button type="button" class="btn btn-success confirm-update">Cập nhật</button>
                                    <button type="button" class="btn btn-danger cancel-update" data-dismiss="modal">Hủy</button>
                                </div>
                            </div>
                        </div>
                    </div>

                    <!-- modal xóa department -->
                    <div class="modal" tabindex="-1" role="dialog" id="modal-delete-department">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title">Delete Department</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                                </div>
                                <div class="modal-body">
                                    <p>Bạn có muốn xóa Phòng Ban này không?</p>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-primary" id="btn-confirm-delete">Xác nhận</button>
                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <hr>
            </div>
        </div>
        </div>
        </div>
        </div>
    </section>
    </div>
</body>

</html>

<script>
    $(document).ready(function() {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        //định nghĩa table Department
        const gCOL_ID = 0;
        const gCOL_MA_PHONG_BAN = 1;
        const gCOL_TEN_PHONG_BAN = 2;
        const gCOL_NGHIEP_VU = 3;
        const gCOL_GIOI_THIEU = 4;
        const gCOL_ACTION = 5;
        var gId = 0;

        const gDEPARTMENT_COLS = ["id", "maPhongBan", "tenPhongBan", "nghiepVu", "gioiThieu", "ngayTao"];
        var gTable = $("#album-table").DataTable({
            columns: [{
                data: gDEPARTMENT_COLS[gCOL_ID]
            }, {
                data: gDEPARTMENT_COLS[gCOL_MA_PHONG_BAN]
            }, {
                data: gDEPARTMENT_COLS[gCOL_TEN_PHONG_BAN]
            }, {
                data: gDEPARTMENT_COLS[gCOL_NGHIEP_VU]
            }, {
                data: gDEPARTMENT_COLS[gCOL_GIOI_THIEU]
            }, {
                data: gDEPARTMENT_COLS[gCOL_ACTION]
            }],
            columnDefs: [{
                "targets": gCOL_ACTION,
                "defaultContent": `<i class="far fa-edit edit-department" style= "color : green ; cursor: pointer;" title="Edit " ></i>  
                            <i class="fas fa-trash-alt delete-department" style= "color : red ; cursor: pointer;" title="Delete"></i>`
            }],
            searching: false,
        });

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading();
        //Gán event handler khi click vào hàng bất kỳ trong table department
        $("#department-table").on("click", "td", function() {
            onDepartmentTableRowClick(this);
        });

        // gán sự kiện cho nút add department
        $("#btn-create-department").on("click", function() {
                $("#modal-create-department").modal("show");
            })
            // confirm department create
        $(document).on("click", ".confirm-create", function() {
            onBtnCreateDepartmentClick();
        });
        // cancel department create
        $(".cancel-create").on("click", function() {
            $("#modal-create-department").modal("hide");
        });

        // gán sự kiện cho nút update department
        $(document).on("click", ".edit-department", function() {
            $("#modal-update-department").modal("show");
            onDepartmentTableRowClick(this);
        });
        $(".confirm-update").on("click", function() {
            onBtnUpdateDepartmentClick();
        });
        $(".cancel-update").on("click", function() {
            $("#modal-update-department").modal("hide");
        });

        // gán sự kiện cho nút delete department
        $(document).on("click", ".delete-department", function() {
            $("#modal-delete-department").modal("show");
            onDepartmentTableRowClick(this);
        });
        // delete department confirm
        $("#btn-confirm-delete").on("click", function() {
            onBtnDeleteDepartmentClick();
        });


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm load trang
        function onPageLoading() {
            "use strict";
            callApiGetAllDepartmentShowOnTable();
        }

        //Hàm thực thi khi click vào hàng bất kỳ
        function onDepartmentTableRowClick(paramTableCell) {
            var vClickedRow = $(paramTableCell).parents("tr");
            var vRowData = gTable.row(vClickedRow).data();
            gId = vRowData.id;
            console.log("Đã click vào row có id là: " + gId);
            callAjaxApiGetDepartmentById(gId);
        }

        //Hàm thực thi khi nhấn nút add album
        function onBtnCreateDepartmentClick() {

            var vObj = {
                maPhongBan: $("#inp-create-ma-phong-ban").val().trim(),
                tenPhongBan: $("#inp-create-ten-phong-ban").val().trim(),
                nghiepVu: $("#inp-create-nghiep-vu").val().trim(),
                gioiThieu: $("#inp-create-gioi-thieu").val().trim()
            };

            var vCheck = validateCreateDepartmentData(vObj);
            if (vCheck == true) {

                $.ajax({
                    url: "http://localhost:8080/department/create",
                    type: "POST",
                    contentType: "application/json",
                    async: false,
                    data: JSON.stringify(vObj),
                    success: function(res) {
                        console.log(res);
                        alert("Tạo Phòng Ban mới thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.responseText);
                    }
                });
            }

        }

        //Hàm thực thi khi nhấn nút update department
        function onBtnUpdateDepartmentClick() {
            "use strict";
            if (gId == 0) {
                alert("Hãy click chọn Phòng Ban cần chỉnh sửa!");
            } else {
                var vObj = {
                    maPhongBan: $("#inp-update-ma-phong-ban").val().trim(),
                    tenPhongBan: $("#inp-update-ten-phong-ban").val().trim(),
                    nghiepVu: $("#inp-update-nghiep-vu").val().trim(),
                    gioiThieu: $("#inp-update-gioi-thieu").val().trim()
                };
            };
            var vCheck = validateUpdateDepartmentData(vObj);
            if (vCheck) {
                $.ajax({
                    url: "http://localhost:8080/departments/update/" + gId,
                    type: "PUT",
                    contentType: "application/json; charset=UTF-8",
                    data: JSON.stringify(vObj),
                    success: function(res) {
                        console.log(res);
                        alert("Cập nhật Phòng Ban thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.responseText);
                    }
                });
            };
        }


        //Hàm thực thi khi nhấn nút Delete department
        function onBtnDeleteDepartmentClick() {
            "use strict";
            console.log(gId);
            if (gId == 0) {
                alert("Hãy click chọn Phòng Ban cần xóa!");
            } else {
                $.ajax({
                    url: "http://localhost:8080/departments/delete/" + gId,
                    type: "DELETE",
                    dataType: "json",
                    success: function(res) {
                        console.log(res);
                        alert("Xóa Phòng Ban thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.response);
                    }
                });
            }
        }

        //Hàm gọi APi lấy ra toàn bộ department
        function callApiGetAllDepartmentShowOnTable() {
            "use strict";
            $.ajax({
                url: "http://localhost:8080/departments",
                type: "GET",
                dataType: "json",
                success: function(res) {
                    console.log(res);
                    gTable.clear();
                    gTable.rows.add(res);
                    gTable.draw();
                },
                error: function(err) {
                    console.log(err.responseText);
                }
            })

        }

        function loadDataIntoSelect(paramObject) {
            for (var bI = 0; bI < paramObject.length; bI++) {
                $('#select-province').append($('<option>', {
                    value: paramObject[bI].id,
                    text: paramObject[bI].name
                }));
            }
        }
        //Hàm gọi API để lấy dữ liệu department theo id
        function callAjaxApiGetDepartmentById(paramId) {
            $.ajax({
                url: "http://localhost:8080/departments/" + paramId,
                type: "GET",
                dataType: "json",
                success: function(res) {
                    console.log(res);
                    loadDepartmentDataToForm(res);
                },
                error: function(err) {
                    console.log(err.responseText);
                }
            })
        }
        //Hàm load dữ liệu department lên form
        function loadDepartmentDataToForm(paramRes) {
            $("#inp-update-ma-phong-ban").val(paramRes.maPhongBan);
            $("#inp-update-ten-phong-ban").val(paramRes.tenPhongBan);
            $("#inp-update-nghiep-vu").val(paramRes.nghiepVu);
            $("#inp-update-gioi-thieu").val(paramRes.gioiThieu);

        }

        //Hàm validate create department
        function validateCreateDepartmentData(paramObj) {
            "use strict"
            if (paramObj.maPhongBan === "") {
                alert("Hãy nhập mã Phòng Ban");
                return false;
            } else if (paramObj.tenPhongBan === "") {
                alert("Hãy nhập tên Phòng Ban");
                return false;
            }
            return true;
        }

        // validate update album
        function validateUpdateDepartmentData(paramObj) {
            "use strict"
            if (paramObj.maPhongBan === "") {
                alert("Hãy nhập mã Phòng Ban!");
                return false;
            } else if (paramObj.tenPhongBan === "") {
                alert("Hãy nhập tên Phòng Ban");
                return false;
            }
            return true;
        }

    });
</script>